//+------------------------------------------------------------------+
//|                             CCI Woodie like - LSMA and EMA lines |
//|                                          CCI woodie LSMA EMA.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Lime
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_color4  Lime
#property indicator_color5  Red
#property indicator_color6  Red
#property indicator_width1  3
#property indicator_width2  3
#property indicator_width3  3
#property indicator_width4  3
#property indicator_width5  3
#property indicator_width6  3

//
//
//
//
//

extern int   LSMAPeriod     = 25;
extern int   LSMAPrice      = PRICE_CLOSE;
extern int   EMAPeriod      = 34;
extern int   EMAPrice       = PRICE_CLOSE;

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,buffer7);
   SetIndexBuffer(7,buffer8);
         SetIndexLabel(0,"Close above LSMA");
         SetIndexLabel(1,"Close bellow LSMA");
         SetIndexLabel(2,"Close bellow LSMA");
         SetIndexLabel(3,"Close above EMA");
         SetIndexLabel(4,"Close bellow EMA");
         SetIndexLabel(5,"Close bellow EMA");

   //
   //
   //
   //
   //
   
   IndicatorShortName("LSMA - EMA");
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int start()
{
   int    counted_bars=IndicatorCounted();
   int    i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;

   //
   //
   //
   //
   //
   
   if (Close[limit] < buffer7[limit]) CleanPoint(limit,buffer2,buffer3);
   if (Close[limit] < buffer8[limit]) CleanPoint(limit,buffer5,buffer6);

   for (i=limit;i>=0;i--)
   {
         buffer7[i] = iLsma(i);
         buffer8[i] = iMA(NULL,0,EMAPeriod,0,MODE_EMA,EMAPrice,i);

         //
         //
         //
         //
         //
            
            buffer1[i] =  3;
            buffer2[i] = EMPTY_VALUE;
            buffer3[i] = EMPTY_VALUE;
            buffer4[i] = -3;
            buffer5[i] = EMPTY_VALUE;
            buffer6[i] = EMPTY_VALUE;
      
            if (Close[i] < buffer7[i]) PlotPoint(i,buffer2,buffer3,buffer1);
            if (Close[i] < buffer8[i]) PlotPoint(i,buffer5,buffer6,buffer4);
   }
   
   //
   //
   //
   //
   //
   
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iLsma(int shift)
{
   double lengthvar = (LSMAPeriod + 1.0)/3.0;
   double sum       = 0.0;
   double res       = 0.0;

   for(int i = LSMAPeriod; i > 0; i--)
      sum += (i-lengthvar)*iMA(NULL,0,1,0,MODE_SMA,LSMAPrice,shift+LSMAPeriod-i);
      res  = sum*6.0/(LSMAPeriod*(LSMAPeriod+1.0));
   return(res);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}